// Generated from libavfilter/opencl/tonemap.cl
const char *ff_source_tonemap_cl =
"/*\n"
" * This file is part of FFmpeg.\n"
" *\n"
" * FFmpeg is free software; you can redistribute it and/or\n"
" * modify it under the terms of the GNU Lesser General Public\n"
" * License as published by the Free Software Foundation; either\n"
" * version 2.1 of the License, or (at your option) any later version.\n"
" *\n"
" * FFmpeg is distributed in the hope that it will be useful,\n"
" * but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
" * Lesser General Public License for more details.\n"
" *\n"
" * You should have received a copy of the GNU Lesser General Public\n"
" * License along with FFmpeg; if not, write to the Free Software\n"
" * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA\n"
" */\n"
"\n"
"#define FLOAT_EPS 1e-6f\n"
"\n"
"extern float3 lrgb2yuv(float3);\n"
"extern float  lrgb2y(float3);\n"
"extern float3 yuv2lrgb(float3);\n"
"extern float3 lrgb2lrgb(float3);\n"
"extern float  eotf_st2084(float);\n"
"extern float  inverse_eotf_st2084(float);\n"
"extern float4 get_luma_dst4(float4, float4, float4);\n"
"extern float3 get_chroma_sample(float3, float3, float3, float3);\n"
"#ifdef DOVI_RESHAPE\n"
"extern float3 rgb2lrgb(float3);\n"
"extern float3 ycc2rgb(float, float, float);\n"
"extern float3 lms2rgb(float, float, float);\n"
"#endif\n"
"extern float4 eotf_st2084x4(float4 x);\n"
"extern float4 inverse_eotf_st2084x4(float4 x);\n"
"#ifdef TONE_MODE_ITP\n"
"extern void lrgb2ictcp(float4 r4, float4 g4, float4 b4, float4* i4, float4* ct4, float4* cp4);\n"
"extern void ictcp2lrgb(float4 i4, float4 ct4, float4 cp4, float4* r4, float4* g4, float4* b4);\n"
"#endif\n"
"extern float3 gamut_compress(float3 rgb);\n"
"\n"
"#ifdef ENABLE_DITHER\n"
"float get_dithered_y(float y, float d) {\n"
"    return floor(y * dither_quantization + d + 0.5f / dither_size2) * 1.0f / dither_quantization;\n"
"}\n"
"#endif\n"
"\n"
"float hable_f(float in) {\n"
"    float a = 0.15f, b = 0.50f, c = 0.10f, d = 0.20f, e = 0.02f, f = 0.30f;\n"
"    return (in * (in * a + b * c) + d * e) / (in * (in * a + b) + d * f) - e / f;\n"
"}\n"
"\n"
"float direct(float s, float peak, float target_peak) {\n"
"    return s;\n"
"}\n"
"\n"
"float linear(float s, float peak, float target_peak) {\n"
"    return s * tone_param / peak;\n"
"}\n"
"\n"
"float gamma(float s, float peak, float target_peak) {\n"
"    float p = s > 0.05f ? s / peak : 0.05f / peak;\n"
"    float v = native_powr(p, 1.0f / tone_param);\n"
"    return s > 0.05f ? v : (s * v / 0.05f);\n"
"}\n"
"\n"
"float clip(float s, float peak, float target_peak) {\n"
"    return clamp(s * tone_param, 0.0f, 1.0f);\n"
"}\n"
"\n"
"float reinhard(float s, float peak, float target_peak) {\n"
"    return s / (s + tone_param) * (peak + tone_param) / peak;\n"
"}\n"
"\n"
"float hable(float s, float peak, float target_peak) {\n"
"    return hable_f(s) / hable_f(peak);\n"
"}\n"
"\n"
"float mobius(float s, float peak, float target_peak) {\n"
"    float j = tone_param;\n"
"    float a, b;\n"
"\n"
"    if (s <= j)\n"
"        return s;\n"
"\n"
"    a = -j * j * (peak - 1.0f) / (j * j - 2.0f * j + peak);\n"
"    b = (j * j - 2.0f * j * peak + peak) / fmax(peak - 1.0f, FLOAT_EPS);\n"
"\n"
"    return (b * b + 2.0f * b * j + j * j) / (b - a) * (s + a) / (s + b);\n"
"}\n"
"\n"
"float bt2390(float s, float peak_inv_pq, float target_peak_inv_pq) {\n"
"    float peak_pq = peak_inv_pq;\n"
"    float scale = peak_pq > 0.0f ? (1.0f / peak_pq) : 1.0f;\n"
"\n"
"    float s_pq = s * scale;\n"
"    float max_lum = target_peak_inv_pq * scale;\n"
"\n"
"    float ks = (1.0f + tone_param) * max_lum - tone_param;\n"
"    float tb = (s_pq - ks) / (1.0f - ks);\n"
"    float tb2 = tb * tb;\n"
"    float tb3 = tb2 * tb;\n"
"    float pb = (2.0f * tb3 - 3.0f * tb2 + 1.0f) * ks +\n"
"               (tb3 - 2.0f * tb2 + tb) * (1.0f - ks) +\n"
"               (-2.0f * tb3 + 3.0f * tb2) * max_lum;\n"
"    float sig = mix(pb, s_pq, s_pq < ks);\n"
"\n"
"    return sig * peak_pq;\n"
"}\n"
"\n"
"#define MAP_FOUR_PIXELS(sig, peak, target_peak) \\\n"
"{ \\\n"
"    sig.x = TONE_FUNC(sig.x, peak, target_peak); \\\n"
"    sig.y = TONE_FUNC(sig.y, peak, target_peak); \\\n"
"    sig.z = TONE_FUNC(sig.z, peak, target_peak); \\\n"
"    sig.w = TONE_FUNC(sig.w, peak, target_peak); \\\n"
"}\n"
"\n"
"#ifndef TONE_MODE_ITP\n"
"void map_four_pixels_rgb(float4 *r4, float4 *g4, float4 *b4, float peak) {\n"
"#ifdef TONE_MODE_RGB\n"
"    float4 sig_r = fmax(*r4, FLOAT_EPS), sig_ro = sig_r;\n"
"    float4 sig_g = fmax(*g4, FLOAT_EPS), sig_go = sig_g;\n"
"    float4 sig_b = fmax(*b4, FLOAT_EPS), sig_bo = sig_b;\n"
"#else\n"
"  #ifdef TONE_MODE_MAX\n"
"    float4 sig = fmax(fmax(*r4, fmax(*g4, *b4)), FLOAT_EPS);\n"
"  #else\n"
"    float4 sig = fmax((*r4 * 0.2627f + *g4 * 0.678f + *b4 * 0.0593f), FLOAT_EPS);\n"
"  #endif\n"
"    float4 sig_o = sig;\n"
"#endif\n"
"\n"
"    // Desaturate the color using a coefficient dependent on the signal level\n"
"    if (desat_param > 0.0f) {\n"
"#ifdef TONE_MODE_RGB\n"
"        float4 sig = fmax(fmax(*r4, fmax(*g4, *b4)), FLOAT_EPS);\n"
"#endif\n"
"#ifdef MAP_IN_DST_SPACE\n"
"        float4 luma = get_luma_dst4(*r4, *g4, *b4);\n"
"#else // only LUM mode currently\n"
"        float4 luma = sig;\n"
"#endif\n"
"        float4 coeff = fmax(sig - 0.18f, FLOAT_EPS) / fmax(sig, FLOAT_EPS);\n"
"        coeff = native_powr(coeff, 10.0f / desat_param);\n"
"        *r4 = mix(*r4, luma, coeff);\n"
"        *g4 = mix(*g4, luma, coeff);\n"
"        *b4 = mix(*b4, luma, coeff);\n"
"    }\n"
"\n"
"#ifdef TONE_FUNC_BT2390\n"
"    float src_peak_delin_pq = inverse_eotf_st2084(peak);\n"
"    float dst_peak_delin_pq = inverse_eotf_st2084(1.0f);\n"
"  #ifdef TONE_MODE_RGB\n"
"    sig_r = inverse_eotf_st2084x4(sig_r);\n"
"    sig_g = inverse_eotf_st2084x4(sig_g);\n"
"    sig_b = inverse_eotf_st2084x4(sig_b);\n"
"    MAP_FOUR_PIXELS(sig_r, src_peak_delin_pq, dst_peak_delin_pq)\n"
"    MAP_FOUR_PIXELS(sig_g, src_peak_delin_pq, dst_peak_delin_pq)\n"
"    MAP_FOUR_PIXELS(sig_b, src_peak_delin_pq, dst_peak_delin_pq)\n"
"    sig_r = eotf_st2084x4(sig_r);\n"
"    sig_g = eotf_st2084x4(sig_g);\n"
"    sig_b = eotf_st2084x4(sig_b);\n"
"  #else\n"
"    sig = inverse_eotf_st2084x4(sig);\n"
"    MAP_FOUR_PIXELS(sig, src_peak_delin_pq, dst_peak_delin_pq)\n"
"    sig = eotf_st2084x4(sig);\n"
"  #endif\n"
"#else\n"
"  #ifdef TONE_MODE_RGB\n"
"    MAP_FOUR_PIXELS(sig_r, peak, 1.0f)\n"
"    MAP_FOUR_PIXELS(sig_g, peak, 1.0f)\n"
"    MAP_FOUR_PIXELS(sig_b, peak, 1.0f)\n"
"  #else\n"
"    MAP_FOUR_PIXELS(sig, peak, 1.0f)\n"
"  #endif\n"
"#endif\n"
"\n"
"#ifdef TONE_MODE_RGB\n"
"    sig_r = fmin(sig_r, 1.0f);\n"
"    sig_g = fmin(sig_g, 1.0f);\n"
"    sig_b = fmin(sig_b, 1.0f);\n"
"    float4 factor_r = sig_r / sig_ro;\n"
"    float4 factor_g = sig_g / sig_go;\n"
"    float4 factor_b = sig_b / sig_bo;\n"
"    *r4 *= factor_r;\n"
"    *g4 *= factor_g;\n"
"    *b4 *= factor_b;\n"
"#else\n"
"    sig = fmin(sig, 1.0f);\n"
"    float4 factor = sig / sig_o;\n"
"    *r4 *= factor;\n"
"    *g4 *= factor;\n"
"    *b4 *= factor;\n"
"#endif\n"
"}\n"
"#endif\n"
"\n"
"#ifdef TONE_MODE_ITP\n"
"void map_four_pixels_itp(float4 *r4, float4 *g4, float4 *b4, float peak) {\n"
"    float4 i4_o, i4, ct4 , cp4;\n"
"    lrgb2ictcp(*r4, *g4, *b4, &i4, &ct4, &cp4);\n"
"    i4 = fmax(i4, FLOAT_EPS);\n"
"    i4_o = i4;\n"
"    if (desat_param > 0.0f) {\n"
"        float4 coeff = native_exp(-pow(eotf_st2084x4(i4) - (target_peak - desat_param) * 0.5f, 2) / (2.0f * peak));\n"
"        ct4 *= coeff;\n"
"        cp4 *= coeff;\n"
"    }\n"
"#ifdef TONE_FUNC_BT2390\n"
"    float src_peak_delin_pq = inverse_eotf_st2084(peak);\n"
"    float dst_peak_delin_pq = inverse_eotf_st2084(1.0f);\n"
"    MAP_FOUR_PIXELS(i4, src_peak_delin_pq, dst_peak_delin_pq)\n"
"#else\n"
"    i4 = eotf_st2084x4(i4);\n"
"    MAP_FOUR_PIXELS(i4, peak, 1.0f)\n"
"    i4 = inverse_eotf_st2084x4(i4);\n"
"#endif\n"
"    i4 = fmin(i4, 1.0f);\n"
"    float4 factor = min(i4/i4_o, i4_o/i4);\n"
"    ct4 *= factor;\n"
"    cp4 *= factor;\n"
"    ictcp2lrgb(i4, ct4, cp4, r4, g4, b4);\n"
"}\n"
"#endif\n"
"\n"
"// Map from source space YUV to source space RGB\n"
"float3 map_to_src_space_from_yuv(float3 yuv) {\n"
"#ifdef DOVI_RESHAPE\n"
"    float3 c = ycc2rgb(yuv.x, yuv.y, yuv.z);\n"
"    c = lms2rgb(c.x, c.y, c.z);\n"
"    c = rgb2lrgb(c);\n"
"#else\n"
"    float3 c = yuv2lrgb(yuv);\n"
"#endif\n"
"    return c;\n"
"}\n"
"\n"
"// Map from source space YUV to destination space RGB\n"
"float3 map_to_dst_space_from_yuv(float3 yuv) {\n"
"#ifdef DOVI_RESHAPE\n"
"    float3 c = ycc2rgb(yuv.x, yuv.y, yuv.z);\n"
"    c = lms2rgb(c.x, c.y, c.z);\n"
"    c = rgb2lrgb(c);\n"
"    c = lrgb2lrgb(c);\n"
"#else\n"
"    float3 c = yuv2lrgb(yuv);\n"
"    c = lrgb2lrgb(c);\n"
"#endif\n"
"    return c;\n"
"}\n"
"\n"
"#ifdef DOVI_RESHAPE\n"
"float reshape_poly(float s, float4 coeffs) {\n"
"    return (coeffs.z * s + coeffs.y) * s + coeffs.x;\n"
"}\n"
"\n"
"float reshape_mmr(float3 sig,\n"
"                  float4 coeffs,\n"
"                  __global float4 *dovi_mmr,\n"
"                  int dovi_mmr_single,\n"
"                  int dovi_min_order,\n"
"                  int dovi_max_order)\n"
"{\n"
"    int mmr_idx = dovi_mmr_single ? 0 : (int)coeffs.y;\n"
"    int order = (int)coeffs.w;\n"
"    float4 sigX;\n"
"\n"
"    float s = coeffs.x;\n"
"    sigX.xyz = sig.xxy * sig.yzz;\n"
"    sigX.w = sigX.x * sig.z;\n"
"    s += dot(dovi_mmr[mmr_idx + 0].xyz, sig);\n"
"    s += dot(dovi_mmr[mmr_idx + 1], sigX);\n"
"\n"
"    int t = dovi_max_order >= 2 && (dovi_min_order >= 2 || order >= 2);\n"
"    if (t) {\n"
"        float3 sig2 = sig * sig;\n"
"        float4 sigX2 = sigX * sigX;\n"
"        s += dot(dovi_mmr[mmr_idx + 2].xyz, sig2);\n"
"        s += dot(dovi_mmr[mmr_idx + 3], sigX2);\n"
"        t = dovi_max_order == 3 && (dovi_min_order == 3 || order >= 3);\n"
"        if (t) {\n"
"            s += dot(dovi_mmr[mmr_idx + 4].xyz, sig2 * sig);\n"
"            s += dot(dovi_mmr[mmr_idx + 5], sigX2 * sigX);\n"
"        }\n"
"    }\n"
"\n"
"    return s;\n"
"}\n"
"\n"
"float3 reshape_dovi_yuv(float3 yuv,\n"
"                        __global float *src_dovi_params,\n"
"                        __global float *src_dovi_pivots,\n"
"                        __global float4 *src_dovi_coeffs,\n"
"                        __global float4 *src_dovi_mmr)\n"
"{\n"
"    int i;\n"
"    float s;\n"
"    float3 sig = clamp(yuv.xyz, 0.0f, 1.0f);\n"
"    float sig_arr[3] = {sig.x, sig.y, sig.z};\n"
"    float4 coeffs;\n"
"    int dovi_num_pivots, dovi_has_mmr, dovi_has_poly;\n"
"    int dovi_mmr_single, dovi_min_order, dovi_max_order;\n"
"    float dovi_lo, dovi_hi;\n"
"    __global float *dovi_params;\n"
"    __global float *dovi_pivots;\n"
"    __global float4 *dovi_coeffs, *dovi_mmr;\n"
"\n"
"#pragma unroll\n"
"    for (i = 0; i < 3; i++) {\n"
"        dovi_params = src_dovi_params + i*8;\n"
"        dovi_pivots = src_dovi_pivots + i*8;\n"
"        dovi_coeffs = src_dovi_coeffs + i*8;\n"
"        dovi_mmr = src_dovi_mmr + i*48;\n"
"        dovi_num_pivots = dovi_params[0];\n"
"        dovi_has_mmr = dovi_params[1];\n"
"        dovi_has_poly = dovi_params[2];\n"
"        dovi_mmr_single = dovi_params[3];\n"
"        dovi_min_order = dovi_params[4];\n"
"        dovi_max_order = dovi_params[5];\n"
"        dovi_lo = dovi_params[6];\n"
"        dovi_hi = dovi_params[7];\n"
"\n"
"        s = sig_arr[i];\n"
"        coeffs = dovi_coeffs[0];\n"
"\n"
"        if (i == 0 && dovi_num_pivots > 2) {\n"
"            coeffs = mix(mix(mix(dovi_coeffs[0], dovi_coeffs[1], (float4)(s >= dovi_pivots[0])),\n"
"                             mix(dovi_coeffs[2], dovi_coeffs[3], (float4)(s >= dovi_pivots[2])),\n"
"                             (float4)(s >= dovi_pivots[1])),\n"
"                         mix(mix(dovi_coeffs[4], dovi_coeffs[5], (float4)(s >= dovi_pivots[4])),\n"
"                             mix(dovi_coeffs[6], dovi_coeffs[7], (float4)(s >= dovi_pivots[6])),\n"
"                             (float4)(s >= dovi_pivots[5])),\n"
"                         (float4)(s >= dovi_pivots[3]));\n"
"        }\n"
"\n"
"        int has_mmr_poly = dovi_has_mmr && dovi_has_poly;\n"
"\n"
"        if ((has_mmr_poly && coeffs.w == 0.0f) || (!has_mmr_poly && dovi_has_poly))\n"
"            s = reshape_poly(s, coeffs);\n"
"        else\n"
"            s = reshape_mmr(sig, coeffs, dovi_mmr,\n"
"                            dovi_mmr_single, dovi_min_order, dovi_max_order);\n"
"\n"
"        sig_arr[i] = clamp(s, dovi_lo, dovi_hi);\n"
"    }\n"
"\n"
"    return (float3)(sig_arr[0], sig_arr[1], sig_arr[2]);\n"
"}\n"
"#endif\n"
"\n"
"__constant sampler_t sampler = (CLK_NORMALIZED_COORDS_FALSE |\n"
"                                CLK_ADDRESS_CLAMP_TO_EDGE   |\n"
"                                CLK_FILTER_NEAREST);\n"
"\n"
"__constant sampler_t l_sampler = (CLK_NORMALIZED_COORDS_TRUE |\n"
"                                  CLK_ADDRESS_CLAMP_TO_EDGE  |\n"
"                                  CLK_FILTER_LINEAR);\n"
"\n"
"__constant sampler_t d_sampler = (CLK_NORMALIZED_COORDS_TRUE |\n"
"                                  CLK_ADDRESS_REPEAT         |\n"
"                                  CLK_FILTER_NEAREST);\n"
"\n"
"__kernel void tonemap(__write_only image2d_t dst1,\n"
"                      __read_only  image2d_t src1,\n"
"                      __write_only image2d_t dst2,\n"
"                      __read_only  image2d_t src2,\n"
"#ifdef NON_SEMI_PLANAR_OUT\n"
"                      __write_only image2d_t dst3,\n"
"#endif\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"                      __read_only  image2d_t src3,\n"
"#endif\n"
"#ifdef ENABLE_DITHER\n"
"                      __read_only  image2d_t dither,\n"
"#endif\n"
"#ifdef DOVI_RESHAPE\n"
"                      __global float *dovi_buf,\n"
"#endif\n"
"                      float peak)\n"
"{\n"
"    int xi = get_global_id(0);\n"
"    int yi = get_global_id(1);\n"
"    // each work item process four pixels\n"
"    int x = 2 * xi;\n"
"    int y = 2 * yi;\n"
"\n"
"    int2 src1_sz = get_image_dim(src1);\n"
"    int2 dst2_sz = get_image_dim(dst2);\n"
"\n"
"    if (xi >= dst2_sz.x || yi >= dst2_sz.y)\n"
"        return;\n"
"\n"
"    float2 src1_sz_recip = native_recip(convert_float2(src1_sz));\n"
"    float2 ncoords_yuv0 = convert_float2((int2)(x,     y)) * src1_sz_recip;\n"
"    float2 ncoords_yuv1 = convert_float2((int2)(x + 1, y)) * src1_sz_recip;\n"
"    float2 ncoords_yuv2 = convert_float2((int2)(x,     y + 1)) * src1_sz_recip;\n"
"    float2 ncoords_yuv3 = convert_float2((int2)(x + 1, y + 1)) * src1_sz_recip;\n"
"\n"
"    float3 yuv0, yuv1, yuv2, yuv3;\n"
"\n"
"    yuv0.x = read_imagef(src1, sampler, (int2)(x,     y)).x;\n"
"    yuv1.x = read_imagef(src1, sampler, (int2)(x + 1, y)).x;\n"
"    yuv2.x = read_imagef(src1, sampler, (int2)(x,     y + 1)).x;\n"
"    yuv3.x = read_imagef(src1, sampler, (int2)(x + 1, y + 1)).x;\n"
"\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"    yuv0.yz = (float2)(read_imagef(src2, l_sampler, ncoords_yuv0).x,\n"
"                       read_imagef(src3, l_sampler, ncoords_yuv0).x);\n"
"    yuv1.yz = (float2)(read_imagef(src2, l_sampler, ncoords_yuv1).x,\n"
"                       read_imagef(src3, l_sampler, ncoords_yuv1).x);\n"
"    yuv2.yz = (float2)(read_imagef(src2, l_sampler, ncoords_yuv2).x,\n"
"                       read_imagef(src3, l_sampler, ncoords_yuv2).x);\n"
"    yuv3.yz = (float2)(read_imagef(src2, l_sampler, ncoords_yuv3).x,\n"
"                       read_imagef(src3, l_sampler, ncoords_yuv3).x);\n"
"#else\n"
"    yuv0.yz = read_imagef(src2, l_sampler, ncoords_yuv0).xy;\n"
"    yuv1.yz = read_imagef(src2, l_sampler, ncoords_yuv1).xy;\n"
"    yuv2.yz = read_imagef(src2, l_sampler, ncoords_yuv2).xy;\n"
"    yuv3.yz = read_imagef(src2, l_sampler, ncoords_yuv3).xy;\n"
"#endif\n"
"\n"
"#ifdef DOVI_RESHAPE\n"
"    __global float *dovi_params = dovi_buf;\n"
"    __global float *dovi_pivots = dovi_buf + 24;\n"
"    __global float4 *dovi_coeffs = (__global float4 *)(dovi_buf + 48);\n"
"    __global float4 *dovi_mmr = (__global float4 *)(dovi_buf + 144);\n"
"    yuv0 = reshape_dovi_yuv(yuv0, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"    yuv1 = reshape_dovi_yuv(yuv1, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"    yuv2 = reshape_dovi_yuv(yuv2, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"    yuv3 = reshape_dovi_yuv(yuv3, dovi_params, dovi_pivots, dovi_coeffs, dovi_mmr);\n"
"#endif\n"
"\n"
"    float3 c0, c1, c2, c3;\n"
"#ifndef MAP_IN_DST_SPACE\n"
"    c0 = map_to_src_space_from_yuv(yuv0);\n"
"    c1 = map_to_src_space_from_yuv(yuv1);\n"
"    c2 = map_to_src_space_from_yuv(yuv2);\n"
"    c3 = map_to_src_space_from_yuv(yuv3);\n"
"#else\n"
"    c0 = map_to_dst_space_from_yuv(yuv0);\n"
"    c1 = map_to_dst_space_from_yuv(yuv1);\n"
"    c2 = map_to_dst_space_from_yuv(yuv2);\n"
"    c3 = map_to_dst_space_from_yuv(yuv3);\n"
"#endif\n"
"\n"
"#ifndef SKIP_TONEMAP\n"
"    float4 r4 = (float4)(c0.x, c1.x, c2.x, c3.x);\n"
"    float4 g4 = (float4)(c0.y, c1.y, c2.y, c3.y);\n"
"    float4 b4 = (float4)(c0.z, c1.z, c2.z, c3.z);\n"
"  #ifdef TONE_MODE_ITP\n"
"    map_four_pixels_itp(&r4, &g4, &b4, peak);\n"
"  #else\n"
"    map_four_pixels_rgb(&r4, &g4, &b4, peak);\n"
"  #endif\n"
"    c0 = (float3)(r4.x, g4.x, b4.x);\n"
"    c1 = (float3)(r4.y, g4.y, b4.y);\n"
"    c2 = (float3)(r4.z, g4.z, b4.z);\n"
"    c3 = (float3)(r4.w, g4.w, b4.w);\n"
"#endif\n"
"\n"
"#ifndef MAP_IN_DST_SPACE\n"
"    c0 = lrgb2lrgb(c0);\n"
"    c1 = lrgb2lrgb(c1);\n"
"    c2 = lrgb2lrgb(c2);\n"
"    c3 = lrgb2lrgb(c3);\n"
"  #if !defined(RGB2RGB_PASSTHROUGH) && !defined(DOVI_PERF_TRADEOFF)\n"
"    c0 = gamut_compress(c0);\n"
"    c1 = gamut_compress(c1);\n"
"    c2 = gamut_compress(c2);\n"
"    c3 = gamut_compress(c3);\n"
"  #endif\n"
"    c0 = clamp(c0, 0.0f, 1.0f);\n"
"    c1 = clamp(c1, 0.0f, 1.0f);\n"
"    c2 = clamp(c2, 0.0f, 1.0f);\n"
"    c3 = clamp(c3, 0.0f, 1.0f);\n"
"#endif\n"
"\n"
"    float y0 = lrgb2y(c0);\n"
"    float y1 = lrgb2y(c1);\n"
"    float y2 = lrgb2y(c2);\n"
"    float y3 = lrgb2y(c3);\n"
"\n"
"#if defined(ENABLE_DITHER) && !defined(SKIP_TONEMAP)\n"
"    int2 dither_sz = get_image_dim(dither);\n"
"    float2 dither_sz_recip = native_recip(convert_float2(dither_sz));\n"
"    float2 ncoords_d = convert_float2((int2)(xi, yi)) * dither_sz_recip;\n"
"    float d = read_imagef(dither, d_sampler, ncoords_d).x;\n"
"    y0 = get_dithered_y(y0, d), y1 = get_dithered_y(y1, d);\n"
"    y2 = get_dithered_y(y2, d), y3 = get_dithered_y(y3, d);\n"
"#endif\n"
"\n"
"    float3 chroma_c = get_chroma_sample(c0, c1, c2, c3);\n"
"    float3 chroma = lrgb2yuv(chroma_c);\n"
"\n"
"    write_imagef(dst1, (int2)(x,     y), (float4)(y0, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst1, (int2)(x + 1, y), (float4)(y1, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst1, (int2)(x,     y + 1), (float4)(y2, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst1, (int2)(x + 1, y + 1), (float4)(y3, 0.0f, 0.0f, 1.0f));\n"
"#ifdef NON_SEMI_PLANAR_OUT\n"
"    write_imagef(dst2, (int2)(xi, yi), (float4)(chroma.y, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst3, (int2)(xi, yi), (float4)(chroma.z, 0.0f, 0.0f, 1.0f));\n"
"#else\n"
"    write_imagef(dst2, (int2)(xi, yi), (float4)(chroma.y, chroma.z, 0.0f, 1.0f));\n"
"#endif\n"
"}\n"
;
